gtkmm: Gtk::PrintJob Class Reference

gtkmm 2.24.4

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::PrintJob Class Reference
Printing

A PrintJob object represents a job that is sent to a printer. More...

Inheritance diagram for Gtk::PrintJob:
[legend]
Collaboration diagram for Gtk::PrintJob:
[legend]

## Public Types
typedef sigc::slot< void, const Glib::RefPtr< PrintJob >& > | SlotPrintJobComplete
| For example, void on_print_job_complete(const Glib::RefPtr<PrintJob>& job);. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Public Member Functions
| PrintJob (PrintJob&& src) noexcept
PrintJob& | operator= (PrintJob&& src) noexcept
| ~PrintJob () noexceptoverride
GtkPrintJob* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkPrintJob* | gobj () const
| Provides access to the underlying C GObject. More...
GtkPrintJob* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< PrintSettings > | get_settings ()
| Gets the Gtk::PrintSettings of the print job. More...
Glib::RefPtr< const PrintSettings > | get_settings () const
| Gets the Gtk::PrintSettings of the print job. More...
Glib::RefPtr< Printer > | get_printer ()
| Gets the Gtk::Printer of the print job. More...
Glib::RefPtr< const Printer > | get_printer () const
| Gets the Gtk::Printer of the print job. More...
Glib::ustring | get_title () const
| Gets the job title. More...
PrintStatus | get_status () const
| Gets the status of the print job. More...
void | set_source_file (const std::string& filename)
| Make the Gtk::PrintJob send an existing document to the printing system. More...
Cairo::RefPtr< Cairo::Surface > | get_surface ()
| Gets a cairo surface onto which the pages of the print job should be rendered. More...
Cairo::RefPtr< const Cairo::Surface > | get_surface () const
| Gets a cairo surface onto which the pages of the print job should be rendered. More...
void | set_track_print_status (bool track_status=true)
| If track_status is `true`, the print job will try to continue report on the status of the print job in the printer queues and printer. More...
bool | get_track_print_status () const
| Returns wheter jobs will be tracked after printing. More...
void | send (const SlotPrintJobComplete& slot)
| Sends the print job off to the printer. More...
Glib::SignalProxy< void > | signal_status_changed ()
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_title () const
| Title of the print job. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Printer > > | property_printer () const
| Printer to print the job to. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< PrintSettings > > | property_settings () const
| Printer settings. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< PageSetup > > | property_page_setup () const
| Page Setup. More...
Glib::PropertyProxy< bool > | property_track_print_status ()
| TRUE if the print job will continue to emit status-changed signals after the print data has been sent to the printer or print server. More...
Glib::PropertyProxy_ReadOnly< bool > | property_track_print_status () const
| TRUE if the print job will continue to emit status-changed signals after the print data has been sent to the printer or print server. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< PrintJob > | create (const Glib::ustring& title, const Glib::RefPtr< Printer >& printer, const Glib::RefPtr< PrintSettings >& settings, const Glib::RefPtr< PageSetup >& page_setup)

## Protected Member Functions
| PrintJob (const Glib::ustring& title, const Glib::RefPtr< Printer >& printer, const Glib::RefPtr< PrintSettings >& settings, const Glib::RefPtr< PageSetup >& page_setup)
virtual void | on_status_changed ()
| This is a default handler for the signal signal_status_changed(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexceptoverride
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::PrintJob > | wrap (GtkPrintJob* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

A PrintJob object represents a job that is sent to a printer.

You only need to deal directly with print jobs if you use the non-portable PrintUnixDialog API.

Use get_surface() to obtain the cairo surface onto which the pages must be drawn. Use send() to send the finished job to the printer.If you don't use cairo then PrintJob also supports printing of manually generated postscript, via set_source_file().

Since gtkmm 2.10:

## Member Typedef Documentation

typedef sigc::slot< void, const Glib::RefPtr<PrintJob>& > Gtk::PrintJob::SlotPrintJobComplete

For example, void on_print_job_complete(const Glib::RefPtr<PrintJob>& job);.

Exceptions

  exception |

## Constructor & Destructor Documentation

Gtk::PrintJob::PrintJob | ( | PrintJob&& | src | ) |
| noexcept

Gtk::PrintJob::~PrintJob | ( |  | ) |
| overridenoexcept

Gtk::PrintJob::PrintJob | ( | const Glib::ustring & | title,
|  | const Glib::RefPtr< Printer >& | printer,
|  | const Glib::RefPtr< PrintSettings >& | settings,
|  | const Glib::RefPtr< PageSetup >& | page_setup
| ) |  |
| explicitprotected

## Member Function Documentation

static Glib::RefPtr<PrintJob> Gtk::PrintJob::create | ( | const Glib::ustring & | title,
|  | const Glib::RefPtr< Printer >& | printer,
|  | const Glib::RefPtr< PrintSettings >& | settings,
|  | const Glib::RefPtr< PageSetup >& | page_setup
| ) |  |
| static

Glib::RefPtr<Printer> Gtk::PrintJob::get_printer | ( |  | ) |

Gets the Gtk::Printer of the print job.

Since gtkmm 2.10:

Returns
  The printer of job.

Glib::RefPtr<const Printer> Gtk::PrintJob::get_printer | ( |  | ) | const

Gets the Gtk::Printer of the print job.

Since gtkmm 2.10:

Returns
  The printer of job.

Glib::RefPtr<PrintSettings> Gtk::PrintJob::get_settings | ( |  | ) |

Gets the Gtk::PrintSettings of the print job.

Since gtkmm 2.10:

Returns
  The settings of job.

Glib::RefPtr<const PrintSettings> Gtk::PrintJob::get_settings | ( |  | ) | const

Gets the Gtk::PrintSettings of the print job.

Since gtkmm 2.10:

Returns
  The settings of job.

PrintStatus Gtk::PrintJob::get_status | ( |  | ) | const

Gets the status of the print job.

Since gtkmm 2.10:

Returns
  The status of job.

Cairo::RefPtr<Cairo::Surface> Gtk::PrintJob::get_surface | ( |  | ) |

Gets a cairo surface onto which the pages of the print job should be rendered.

Since gtkmm 2.10:

Returns
  The cairo surface of job.

Cairo::RefPtr<const Cairo::Surface> Gtk::PrintJob::get_surface | ( |  | ) | const

Gets a cairo surface onto which the pages of the print job should be rendered.

Since gtkmm 2.10:

Returns
  The cairo surface of job.

Glib::ustring Gtk::PrintJob::get_title | ( |  | ) | const

Gets the job title.

Since gtkmm 2.10:

Returns
  The title of job.

bool Gtk::PrintJob::get_track_print_status | ( |  | ) | const

Returns wheter jobs will be tracked after printing.

For details, see set_track_print_status().

Since gtkmm 2.10:

Returns
  `true` if print job status will be reported after printing.

static GType Gtk::PrintJob::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GtkPrintJob* Gtk::PrintJob::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GtkPrintJob* Gtk::PrintJob::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GtkPrintJob* Gtk::PrintJob::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

virtual void Gtk::PrintJob::on_status_changed | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_status_changed().

PrintJob& Gtk::PrintJob::operator= | ( | PrintJob&& | src | ) |
| noexcept

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<PageSetup> > Gtk::PrintJob::property_page_setup | ( |  | ) | const

Page Setup.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Printer> > Gtk::PrintJob::property_printer | ( |  | ) | const

Printer to print the job to.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<PrintSettings> > Gtk::PrintJob::property_settings | ( |  | ) | const

Printer settings.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::PrintJob::property_title | ( |  | ) | const

Title of the print job.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::PrintJob::property_track_print_status | ( |  | ) |

TRUE if the print job will continue to emit status-changed signals after the print data has been sent to the printer or print server.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::PrintJob::property_track_print_status | ( |  | ) | const

TRUE if the print job will continue to emit status-changed signals after the print data has been sent to the printer or print server.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

void Gtk::PrintJob::send | ( | const SlotPrintJobComplete& | slot | ) |

Sends the print job off to the printer.

Parameters

  slot | A function to call when the job completes or an error occurs.

void Gtk::PrintJob::set_source_file | ( | const std::string & | filename | ) |

Make the Gtk::PrintJob send an existing document to the printing system.

The file can be in any format understood by the platforms printing system (typically PostScript, but on many platforms PDF may work too). See Gtk::Printer::accepts_pdf() and Gtk::Printer::accepts_ps().

Since gtkmm 2.10:

Parameters

  filename | The file to be printed.

Returns
  `false` if an error occurred.

void Gtk::PrintJob::set_track_print_status | ( | bool | track_status = `true` | ) |

If track_status is `true`, the print job will try to continue report on the status of the print job in the printer queues and printer.

This can allow your application to show things like "out of paper" issues, and when the print job actually reaches the printer.

This function is often implemented using some form of polling, so it should not be enabled unless needed.

Since gtkmm 2.10:

Parameters

  track_status | `true` to track status after printing.

Glib::SignalProxy< void > Gtk::PrintJob::signal_status_changed | ( |  | ) |

Slot Prototype:
  `void on_my_status_changed()`

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::PrintJob > wrap | ( | GtkPrintJob * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/printjob.h